#include "integer.h"
#include "object.h"
#include <stdio.h>

void _internal_array_copyout(object * array, int32_t index, object * dest)
{
	t_Array * arr = (t_Array *)array;
	memcpy(((char *)dest) + sizeof(object), ((char *)array) + sizeof(t_Array) + arr->payload.Eltype->bp->size * index, get_blueprint(dest)->size);
	get_blueprint(dest)->copy(dest);
}

void _internal_array_copyin(object * array, int32_t index, object * val)
{
	t_Array * arr = (t_Array *)array;
	memcpy(((char *)array) + sizeof(t_Array) + arr->payload.Eltype->bp->size * index, ((char *)val) + sizeof(object), arr->payload.Eltype->bp->size);
	get_blueprint(val)->copy(val);
}

object * _internal_array_getboxed(object * array, int32_t index)
{
	object * ret;
	object ** intarr = (object **)(((char *) array) + sizeof(t_BoxedSP_Array));
	ret = add_ref(intarr[index]);
	release_ref(array);
	return ret;
}

void _internal_array_setboxed(object *array, int32_t index, object * val)
{
	object ** intarr = (object **)(((char *) array) + sizeof(t_BoxedSP_Array));
	intarr[index] = val;
}

object *_internal_array_allocboxed(int32_t size)
{
	t_BoxedSP_Array * ret = (t_BoxedSP_Array *)new_multisize(TYPE_BOXEDARRAY, sizeof(nt_BoxedSP_Array)+sizeof(object *)*size);
	ret->payload.Length = 0;
	ret->payload.Storage = size;
	
	return (object *)ret;
}

object *_internal_array_allocboxedcopy(object * osource, int32_t size)
{
	int32_t tocopy,idx;
	object **srcarr, **destarr;
	t_BoxedSP_Array * source = (t_BoxedSP_Array *)osource;
	t_BoxedSP_Array * ret = (t_BoxedSP_Array *)new_multisize(TYPE_BOXEDARRAY, sizeof(nt_BoxedSP_Array)+sizeof(object *)*size);
	ret->payload.Length = 0;
	ret->payload.Storage = size;
	tocopy = size < source->payload.Length ? size : source->payload.Length;
	srcarr = (object **)(source+1);
	destarr = (object **)(ret+1);
	for(idx = 0; idx < tocopy; ++idx)
		destarr[idx] = srcarr[idx];
	release_ref(osource);
	
	return (object *)ret;
}

object * _internal_array_allocnaked(int32_t size , object * type)
{
	t_Array * ret;
	t_Blueprint * bp = (t_Blueprint *)type;
	if (bp->bp->size < 0) {
		release_ref(type);
		return _internal_array_allocboxed(size);
	}	
	ret = (t_Array *)new_multisize(TYPE_ARRAY, sizeof(nt_Array)+bp->bp->size*size);
	ret->payload.Length = 0;
	ret->payload.Storage = size;
	ret->payload.Eltype = bp;
	
	return (object *)ret;
}

object * _internal_array_allocnakedcopy(object * osource, int32_t size)
{
	int32_t tocopy,idx;
	char *cur;
	t_Array * ret, *source = (t_Array *)osource;
	t_Blueprint * bp = source->payload.Eltype;
	
	ret = (t_Array *)new_multisize(TYPE_ARRAY, sizeof(nt_Array)+bp->bp->size*size);
	ret->payload.Length = 0;
	ret->payload.Storage = size;
	add_ref((object *)bp);
	ret->payload.Eltype = bp;
	tocopy = size < source->payload.Length ? size : source->payload.Length;
	memcpy(ret+1, source+1, tocopy*bp->bp->size);
	//Lower type IDs don't have any reference params so we can safely skip this for those
	if(bp->bp->type_id >= TYPE_ARRAY)
	{
		//Ugly hack
		cur = ((char *)(ret+1))-sizeof(object) ;
		for(idx=0; idx < tocopy; ++idx)
		{
			bp->bp->copy((object *)cur);
			cur += bp->bp->size;
		}
	}
	fflush(stdout);
	release_ref(osource);
	
	return (object *)ret;
}

